'FFSubmenu=Tools
'FFName=Grentest


'(c) Harald Maeckler, Dsseldorf 2020
' ***********************************************************************
' Groessentest.vbs (Skript fr FixFoto)
' Bildergre testen auf Sollabweichung
' ***********************************************************************

' Version 1.00 vom 17.11.2022	- Betaversion
' ***********************************************************************

'**Start Encode**

Option Explicit

'Updatekonstanten und Variable
const SkriptVersion = "1.00"
const SkriptURL = "https://www.ffsf.de/resources/dpi-checker.249/"	'###
Dim UrlVersion,UrlV_Zahl,SkriptV_Zahl,SkriptEnde

'allgemeine Konstanten und Variable
const ForReading = 1, ForWriting = 2
Dim Abbruch,Antwort

'Spezifische Konstanten und Variable
const AWtexte = "alle Bilder des Computerverzeichnis|markierte Bilder des Computervererzeichnis|alle Bilder der aktiven Bilderliste|markierte Bilder der aktiven Bilderliste"
Dim AWarray,Auswahl
Dim SB,SH,Liste

'Objekte
Dim objFS,WshShell
Set objFS = CreateObject("Scripting.FileSystemObject")
Set WshShell = CreateObject("WScript.Shell")

'Lschroutine
Dim SkriptKill,TempFile	 : SkriptKill = false
Dim SkriptName
const Skript = "Groessentest"					'Skriptname
const RegSchluessel = "FF_Groessentest"			'Registryschlssel

' ***********************************************************************
call main
Set WshShell = Nothing
Set objFS = Nothing
' ***********************************************************************
Sub main

on error resume next							'Kontrolle ob Skript in FF-Umgebung gestartet wurde
	FF_GetScriptPath
 	if err <> 0 then
		msgbox "Das Skript funktioniert nur in der Programmumgebung von FixFoto!",vbCritical,"Abbruch"
		exit sub
	end if
on error goto 0

if objFS.FileExists(FF_GetScriptPath & "\" & Skript & ".vbs") then
	SkriptName = Skript & ".vbs"
elseif objFS.FileExists(FF_GetScriptPath & "\" & Skript & ".vbe") then
	SkriptName = Skript & ".vbe"
else
	msgbox "Das Skript wurde umbenannt!",vbCritical,"Abbruch"
	exit sub
end if

'** Start Dialog Bildgrentest **
FF_AddDialog "Bildgrentest",144,134
FF_AddControl "Bildgrentest","Liste abweichender Bilder","GROUP",5,69,132,25
FF_AddControl "Bildgrentest","Sollgre","GROUP",5,36,132,25
FF_AddControl "Bildgrentest","Auswahl","GROUP",5,5,132,25
FF_AddControl "Bildgrentest","Bilderauswahl","COMBO",12,15,120,10
FF_AddControl "Bildgrentest","Fortschritt","PROGRESS",6,103,132,4
FF_AddControl "Bildgrentest","?","BUTTON",5,115,11,11
FF_AddControl "Bildgrentest","|","STATIC",18,115,20,11
FF_SetControlStyle "Bildgrentest","|",1
FF_AddControl "Bildgrentest","Update","BUTTON",40,115,25,11
FF_AddControl "Bildgrentest","Abbrechen","BUTTON",70,115,33,11
FF_AddControl "Bildgrentest","Start","BUTTON",104,115,33,11
FF_AddControl "Bildgrentest","&delete","BUTTON",0,0,1,1
FF_AddControl "Bildgrentest","Breite","STATIC",12,46,18,10
FF_AddControl "Bildgrentest","Hhe","STATIC",80,46,18,10
FF_AddControl "Bildgrentest","SB","SLEDIT",33,46,33,10
FF_SetControlStyle "Bildgrentest","SB",8193
FF_AddControl "Bildgrentest","SH","SLEDIT",99,46,33,10
FF_SetControlStyle "Bildgrentest","SH",8193
FF_AddControl "Bildgrentest","Liste","SLEDIT",12,79,120,10
FF_SetControlStyle "Bildgrentest","Liste",1
'** End Dialog Bildgrentest **

AWarray = split(AWtexte,"|")
for Auswahl = 0 to ubound(AWarray)
	FF_SetControl "Bildgrentest","Bilderauswahl",AWarray(Auswahl)
next

call RegistryLesen

'Tooltips
if Version_OK("3.30.06") then
	FF_SetControlTooltip "Bildgrentest","?", "" &_
						 "Anzeige der Kurzbeschreibung"
	FF_SetControlTooltip "Bildgrentest","Update", "" &_
						 "Prfung ob eine neue Version vorliegt"
	FF_SetControlTooltip "Bildgrentest","Abbrechen", "" &_
						 "Skript beenden"
	FF_SetControlTooltip "Bildgrentest","Start", "" &_
						 "Starten der Anwendung"
end if

if Version_OK("3.40.52") then FF_SetTooltipDelay 2500
FF_SetDialogTimer "Bildgrentest", 100
FF_ActivateControl "Bildgrentest","&delete"

do
	Abbruch = false
	Select Case FF_ShowDialog ("Bildgrentest")
	Case "TIMER"
		FF_SetDialogTimer "Bildgrentest", 0
		FF_SetControl "Bildgrentest" ,"|", "V " & Skriptversion
	Case "&delete"
		Antwort = msgbox("Soll das Skript " & SkriptName & vbNewline & _
						 "wirklich gelscht werden?", _
						 vbYesNo + vbQuestion,"Sicherheitsabfrage")
		if Antwort = vbYes then
			SkriptKill = true
			exit do
		end if
	Case "?"
		'FF_SetControl "Bildgrentest","Fortschritt",65	'############## nur fr Screenshot
		WshShell.Popup "" & _
			"Das Skript dient dazu, ausgewhlte Bilder auf Einhaltung" & vbNewLine &_
			"einer vorgebbaren Sollgre zu testen. Abweichende Bilder" & vbNewLine &_
			"werden in einer Bilderliste angezeigt." & vbNewLine & vbNewLine &_
			"Mit Bettigung der Tastenkombination Alt + D kann fr das" & vbNewLine &_
			"Skript eine Lschroutine aufgerufen werden." & vbNewLine &_
			"",,"Erluterungen",vbInformation
	Case "Update"
		if InternetConnection then
			SkriptEnde = false
			call Update
			if SkriptEnde then exit do
		end if
	Case "Abbrechen","CANCEL"
		exit do
	Case "Start"
		call Werte_auslesen
		call Kontrolle
		if not Abbruch then
			call Schleife
			exit do
		end if

	End Select
loop

call RegistrySchreiben
FF_CloseDialog ("Bildgrentest")
if SkriptKill then			'ggf. Skript komplett entfernen
	call KillSkript
end if

end sub
'------------------------------------------------------------------------
Sub Schleife
Dim bilder,bild_array,Anz,n
DIM IB,IH

bilder = FF_GetSelection(Auswahl)
if len(bilder) = 0 then
	msgbox "Im Computerverzeichnis sind keine Bilder markiert!",vbInformation,"Abbruch"
	Abbruch = true : exit sub
end if

bild_array = split(bilder,vbNewline)
Anz = ubound(bild_Array) +1

FF_IListDelete(Liste)
FF_IListCreate(Liste)

For n = 0 to Anz -1
	FF_LoadImage bild_Array(n)

	IB = FF_GetImageWidth
	IH = FF_GetImageHeight
	
	if SB * 1 <> IB or SH *1 <> IH then
		FF_IListInsertFile Liste,bild_Array(n),-1
	end if

	'### Fortschrittsanzeige
	FF_SetControl "Bildgrentest","Fortschritt",(n +1)/Anz*100

	'### Abbruch?
	if FF_CheckKey() = 8 then 	'8 = Backspace
		Antwort = msgbox("Von " & Anz & " Bildern wurden bisher " & n +1 & " Bilder bearbeitet." & vbNewLine & vbNewLine & _
						 "Soll die Bearbeitung abgebrochen werden?",vbYesNo or vbQuestion,"Abfrage")
		if Antwort = vbYes then exit sub
	end if
next

if FF_IListGetCount(Liste) = 0 then
	FF_IListDelete(Liste)
	msgbox "Die " & Anz & " getesteten Bildern entsprechen" & vbNewLine & "alle der Sollgre.",vbInformation,"Schlussmeldung"
else
	FF_IListSave(Liste)
	msgbox "Von den " & Anz & " getesteten Bildern entsprechen" & vbNewLine & FF_IListGetCount(Liste) & " nicht der Sollgre." & vbNewLine &_
		   "Die abweichenden Bilder werden in der Liste " & Liste & " angezeigt.",vbInformation,"Schlussmeldung"
end if


End Sub
'------------------------------------------------------------------------
Sub Werte_auslesen

Dim AuswahlWert

'Auswahl
'0 = alle Bilder des Computerverzeichnis
'1 = selekt. Bilder des Computerverzeichnis
'2 = alle Bilder der Bilderliste
'3 = selektierte Bilder der Bilderliste
'4 = Bilder des Computerverz. mit Unterordnern

AuswahlWert = FF_GetControl("Bildgrentest","Bilderauswahl")
for Auswahl = 0 to ubound(AWarray)
	if AWarray(Auswahl) = Auswahlwert then exit for
next

SB = FF_GetControl("Bildgrentest","SB")
SH = FF_GetControl("Bildgrentest","SH")
Liste = FF_GetControl("Bildgrentest","Liste")

End Sub
'------------------------------------------------------------------------
Sub Kontrolle

if len(SB) = 0 or len(SH) = 0 then
	msgbox "Es mssen Sollwerte eingetragen werden!",vbExclamation,"Meldung"
	Abbruch = true : exit sub
end if

if SB = 0 or SH = 0 then
	msgbox "Es mssen Sollwerte > 0 eingetragen werden!",vbExclamation,"Meldung"
	Abbruch = true : exit sub
end if

if len(Liste) = 0 then
	msgbox "Es mus ein Listenname eingetragen werden!",vbExclamation,"Meldung"
	Abbruch = true : exit sub
end if

End Sub
'------------------------------------------------------------------------
Sub RegistryLesen
'Schlsselname = HKEY_CURRENT_USER\Software\Joachim Koopmann Software\FixFoto\Script\ & RegSchluessel

'### Werte auslesen

'Auswahl
Auswahl = FF_GetProfile (RegSchluessel,"Auswahl")
if Auswahl = "" then Auswahl = 1

'Sollgren + Liste
SB = FF_GetProfile (RegSchluessel,"SB")
if SB = "" then SB = 1800

SH = FF_GetProfile (RegSchluessel,"SH")
if SH = "" then SB = 1200

Liste = FF_GetProfile (RegSchluessel,"Liste")
if Liste = "" then Liste = "Grenabweichung"

'### Werte eintragen

'Auswahl
FF_SetControl "Bildgrentest","Bilderauswahl",AWarray(Auswahl)

'Sollgren + Liste
FF_SetControl "Bildgrentest","SB",SB
FF_SetControl "Bildgrentest","SH",SH
FF_SetControl "Bildgrentest","Liste",Liste

End Sub
'------------------------------------------------------------------------
Sub RegistrySchreiben
'Schlsselname = HKEY_CURRENT_USER\Software\Joachim Koopmann Software\FixFoto\Script\ & RegSchluessel

call Werte_Auslesen

'Werte schreiben
FF_WriteProfile RegSchluessel,"Auswahl",Auswahl
FF_WriteProfile RegSchluessel,"SB",SB
FF_WriteProfile RegSchluessel,"SH",SH
FF_WriteProfile RegSchluessel,"Liste",Liste

End Sub
'------------------------------------------------------------------------
'************************************************************************
'Internetverbindung ?
'************************************************************************
'------------------------------------------------------------------------
Function InternetConnection
 
Dim obj
Set obj = GetObject("winmgmts:Win32_PingStatus.address='" & "google.de" & "'")

if IsNull(obj.StatusCode) or obj.StatusCode <> 0 Then
   msgbox "Keine Internetverbindung!",vbInformation,"Hinweis"
   InternetConnection = false
else
   InternetConnection = true
end if
 
End Function
'------------------------------------------------------------------------
'************************************************************************
'Update-Funktion
'************************************************************************
'------------------------------------------------------------------------
Sub Update
Dim Antwort

call Versionsermittlung_url

if not Abbruch then
	SkriptV_Zahl = Replace(SkriptVersion,".","") *1
	
	if UrlV_Zahl = SkriptV_Zahl then
		msgbox "Die Version " & SkriptVersion & " ist aktuell!",vbInformation,"Versionsmeldung"
	elseif SkriptV_Zahl < UrlV_Zahl then
		Antwort = msgbox("Die Skriptversion " & SkriptVersion & " ist nicht mehr aktuell!" & vbNewLine &_
				"Es steht die Version " & UrlVersion & " zum Download bereit." & vbNewLine & vbNewLine & _
				"Soll die Downloadseite aufgerufen werden?",vbQuestion + vbYesNo,"Versionsmeldung")
		if Antwort = vbYes then
			on error resume next
			WshShell.Run SkriptUrl,1,false
			if err <> 0 then
				msgbox "Die Downloadseite wurde nicht gefunden!",vbExclamation,"Hinweis"
			else
				SkriptEnde = true
			end if
			on error goto 0
		end if
	else
		msgbox 	"Es liegt ein Fehler in den Versionsangaben vor." & vbNewLine &_
				"Die Skriptversion " & SkriptVersion & " ist grer als die auf" & vbNewLine &_
				"der Downloadseite angegebene Version " & UrlVersion & ".",vbInformation,"Fehlermeldung"
	end if
end if

End Sub
'------------------------------------------------------------------------
Sub Versionsermittlung_url

const VersVortext = "Version:"
Dim Inhalt,pos1,pos2,xml
Dim Fehler : Fehler = false

on error resume next

Set xml = CreateObject("Microsoft.XMLHTTP")
xml.Open "Get",SkriptUrl,false
xml.Send

Inhalt = xml.responseText

if err <> 0 then
	Fehler = true
else
	'Version suchen und anzeigen	
	pos1 = instr(Inhalt,VersVortext)
	if pos1 > 0 then
		pos2 = instr(pos1 ,Inhalt,".")
		if pos2 > 0 then
			pos2 = pos2 +3
			UrlVersion = trim(mid(Inhalt,pos1,pos2-pos1))
		else
			Fehler = true
		end if
	else
		Fehler = true
	end if
end if

Set xml = nothing
On Error GoTo 0

if Fehler then
	msgbox  "Die Versionsangabe wurde nicht gefunden!" & vbNewLine &_
			"Mglicherweise funktioniert der Internetaufruf nicht." & vbNewLine & vbNewLine & _
			"Am besten nochmal probieren!",vbExclamation,"Fehlermeldung"
	Abbruch = true
	exit sub
end if

'Version als Zahl
UrlVersion = trim(mid(UrlVersion,len(VersVortext) +1))
UrlV_Zahl = Replace(UrlVersion,".","") *1
'Msgbox "|" & UrlV_Zahl & "|"

End Sub
'------------------------------------------------------------------------
'************************************************************************
'Lschroutine
'************************************************************************
'------------------------------------------------------------------------
Sub KillSkript
'Skript mit allen Komponenten entfernen

Dim SPfad

'### FixFotoScript.ini bereinigen
TempFile = FF_GetFFPathEx(1) & "\FixFotoScript.ini"
if objFS.FileExists(TempFile) then
	call IniBereinigung
	if Abbruch then exit sub
else
	msgbox 	"Die Datei FixFotoScript.ini konnte nicht gefunden werden." & vbNewLine & _
			"Der Lschvorgang wird abgebrochen!",vbExclamation,"Hinweis"
	exit sub
end if

'### zip-Archiv auf Wunsch sichern, dann lschen
TempFile = FF_GetScriptPath & "\" & objFS.GetBaseName(Skriptname) & ".zip"
if objFS.FileExists(TempFile) then
	Antwort = msgbox("Soll das Archiv " & objFS.GetBaseName(Skriptname) & ".zip" & _
			 " gesichert werden?",vbYesNo + vbQuestion,"Sicherheitskopie")
	if Antwort = vbYes then
		SPfad = FF_EnterPath(true,"Wo soll die Sicherheitskopie angelegt werden?")
		if SPfad = "" then
			msgbox "Das Lschen des Skripts wird abgebrochen!",vbExclamation,"Hinweis"
			exit sub
		end if
		SPfad = SPfad & "\" & objFS.GetBaseName(Skriptname) & ".zip"
		objFS.CopyFile Tempfile, SPfad, true
	end if
	objFS.DeleteFile TempFile,true
end if

'### Skriptdatei lschen
TempFile = FF_GetScriptPath & "\" & Skriptname
objFS.DeleteFile TempFile,true

'### evtl. beigepackte bzw. erzeugte Dateien lschen
'TempFile = """" & FF_GetScriptPath & "\SetDate\SetDate.pdf" & """"			'Dateien
'if objFS.FileExists(TempFile) then objFS.DeleteFile TempFile,true

'### evtl. beigepackte bzw. erzeugte Ordner lschen
'TempFile = FF_GetScriptPath & "\MeckiScript\SetDate"						'Ordner
'if objFS.FolderExists(TempFile) then objFS.DeleteFolder TempFile,true

'### ggf. Registry-Daten lschen
TempFile = "HKEY_CURRENT_USER\Software\Joachim Koopmann Software\FixFoto\Script\" & RegSchluessel & "\"
WshShell.RegDelete(TempFile)

'### Fertigmeldung
msgbox "Das Skript" & Skriptname & vbNewLine & "wurde mit allen Komponenten gelscht!" & vbNewLine & _
	   "Es wird empfohlen die 'Automatische Skriptkonfiguration' aufzurufen.",vbExclamation,"Hinweis"

End Sub
'------------------------------------------------------------------------
Sub IniBereinigung
'FixFotoScript.ini - Bereinigung

Dim Zeile, zNr,Anfang, Ende, DateiTmp, ZielZeile, tmpString
DateiTmp =  FF_GetFFPathEx(1) & "\FixFotoScript.tmp"

'### Wo befindet sich der Eintrag zum Skript?
Set Zeile = objFS.OpenTextFile(TempFile, ForReading)

zNr = 0
do Until Zeile.AtEndOfStream
	tmpString = Zeile.ReadLine
	zNr = zNr + 1
	if tmpString = "[Script]" then Anfang = zNr
	if tmpString = "File=.\" & Skriptname then
		Ende = zNr
		exit do	
	end if
loop 
Zeile.Close

if Ende <= Anfang then
	msgbox 	"Die Datei FixFotoScript.ini konnte nicht bereinigt werden." & vbNewLine & _
		"Der Lschvorgang wird abgebrochen!",vbExclamation,"Hinweis"
	Abbruch = true
	exit sub
end if

'### Zeilen ohne skriptbezogene Zeilen in DateiTmp bertragen
Set Zeile = objFS.OpenTextFile(TempFile, ForReading)
Set ZielZeile  = objFS.CreateTextFile(DateiTmp, True)

zNr = 0
do Until Zeile.AtEndOfStream
	tmpString = Zeile.ReadLine
	zNr = zNr + 1
	if zNr < Anfang or zNr > Ende then
		ZielZeile.WriteLine tmpString
	end if
loop 

Zeile.Close
ZielZeile.Close

'### Umkopieren von DateiTmp nach FixFotoScript.ini (TempFile)
objFS.CopyFile DateiTmp, TempFile, True
objFS.DeleteFile (DateiTmp)

End Sub
'------------------------------------------------------------------------
'************************************************************************
'Standard-Funktionen
'************************************************************************
'------------------------------------------------------------------------
Function Version_OK(MinVersion)
dim VersNr

 VersNr=split(MinVersion,".")
 Version_OK=FF_GetMajor * 1000 + FF_GetMinor + FF_GetBuild / 1000 >=_
     		VersNr(0) * 1000 + VersNr(1) + VersNr(2) / 1000

End Function
'------------------------------------------------------------------------
